from collections import defaultdict

def tournament_results(k, results):
    # Initialize a dictionary to keep track of players and their status (active or eliminated)
    players = {i: "active" for i in range(2 ** k)}

    # Initialize a dictionary to store the results of each match
    match_results = defaultdict(list)

    # Process the results and update player status
    for result in results:
        winner, loser = result
        match_results[winner].append(loser)
        players[loser] = "eliminated"

    # Function to simulate one round of the tournament
    def simulate_round(active_players):
        next_round_players = []
        for i in range(0, len(active_players), 2):
            player1 = active_players[i]
            player2 = active_players[i + 1]
            winner = match_results[player1].pop(0) if player1 in match_results else player1
            next_round_players.append(winner)
            players[player2] = "eliminated"
        return next_round_players

    # Simulate the tournament rounds
    for _ in range(k):
        active_players = [player for player, status in players.items() if status == "active"]
        active_players = simulate_round(active_players)

    # Find the winner and runner-up
    winner = max(players, key=lambda x: players[x])
    players[winner] = "winner"
    runner_up = max(players, key=lambda x: players[x])

    return winner, runner_up, [player for player, status in players.items() if status == "eliminated"]

# Input reading
k = int(input())
results = [list(map(int, input().split())) for _ in range(2 ** k - 1)]

# Call the function and print the results
winner, runner_up, eliminated_players = tournament_results(k, results)
print(winner)
print(runner_up)
for eliminated_round in eliminated_players:
    print(" ".join(map(str, eliminated_round)))