class Igrac:
    def __init__(self, ime):
        self.ime = ime
        self.prolazi_u_sledece_kolo = None

def napravi_turnir(pobednici):
    kolo = []
    for pobednik in pobednici:
        igrac = Igrac(pobednik)
        kolo.append(igrac)
    return kolo

def organizuj_turnir(k, rezultati):
    takmicari = set()
    for par in rezultati:
        takmicari.add(par[0])
        takmicari.add(par[1])

    takmicari = list(takmicari)
    takmicari.sort()

    trenutni_kolo = napravi_turnir(takmicari)

    for i in range(k):
        sledeci_kolo = []
        for par in rezultati:
            pobednik, gubitnik = par
            if pobednik in [igrac.ime for igrac in trenutni_kolo]:
                igrac = Igrac(pobednik)
                igrac.prolazi_u_sledece_kolo = gubitnik
                sledeci_kolo.append(igrac)

        trenutni_kolo = sledeci_kolo

    return trenutni_kolo

# Ucitavanje broja kola
k = int(input("Unesite broj kola (1 <= k <= 15): "))

# Ucitavanje rezultata
rezultati = []
for _ in range(2 ** k - 1):
    par = input("Unesite rezultat meca (pobednik gubitnik): ").split()
    rezultati.append((par[0], par[1]))

# Organizuj turnir i dobij pobednike
pobednici_turnira = organizuj_turnir(k, rezultati)

# Ispiši rezultate
print("Kraj turnira. Pobednici su:")
for pobednik in pobednici_turnira:
    print(f"{pobednik.ime} - prolazi u sledece kolo, gubi od {pobednik.prolazi_u_sledece_kolo}")