def moze_formirati_kvadar(n, duzine):
    # Funkcija koja ispituje da li se moze formirati kvadar od datih šibica
    
    # Sortiramo šibice od najduže ka najkrace
    duzine.sort(reverse=True)
    
    # Rekurzivna funkcija koja proverava da li se može formirati kvadar
    def proveri_kvadar(trenutna_strana, indeks):
        # Ako smo proverili sve šibice, proveravamo da li su sve strane kvadrata jednake
        if indeks == n:
            return trenutna_strana[0] == trenutna_strana[1] == trenutna_strana[2] == trenutna_strana[3]
        
        # Pokušavamo dodati trenutnu šibicu na neku stranu
        for i in range(4):
            if trenutna_strana[i] + duzine[indeks] <= pola_obima:
                trenutna_strana[i] += duzine[indeks]
                if proveri_kvadar(trenutna_strana, indeks + 1):
                    return True
                trenutna_strana[i] -= duzine[indeks]
        
        return False
    
    # Ukupna dužina šibica
    ukupna_duzina = sum(duzine)
    
    # Ako ukupna dužina nije deljiva sa 4, kvadar se ne može formirati
    if ukupna_duzina % 4 != 0:
        return 0
    
    # Pola obima kvadrata
    pola_obima = ukupna_duzina // 4
    
    # Poziv rekurzivne funkcije
    return 1 if proveri_kvadar([0, 0, 0, 0], 0) else 0

# Ucitavanje ulaza
n = int(input())
duzine = list(map(int, input().split()))

# Poziv funkcije i ispis rezultata
rezultat = moze_formirati_kvadar(n, duzine)
print(rezultat)