import itertools

def rastojanje(lopta1, lopta2):
    x1, y1 = lopta1
    x2, y2 = lopta2
    return ((x1 - x2) ** 2 + (y1 - y2) ** 2) ** 0.5

def najkraca_distanca(lokacije):
    n = len(lokacije)
    najbolji_redosled = None
    najmanja_distanca = float('inf')

    for permutacija in itertools.permutations(range(n)):
        distanca = sum(rastojanje(lokacije[permutacija[i]], lokacije[permutacija[i+1]]) for i in range(n-1))
        if distanca < najmanja_distanca:
            najmanja_distanca = distanca
            najbolji_redosled = permutacija

    return najbolji_redosled

# Unos podataka
n = int(input())
lokacije = [list(map(float, input().split())) for _ in range(n)]

# Pronalaženje najkrace distance
optimalan_redosled = najkraca_distanca(lokacije)

# Ispis rezultata
print(*[optimalan_redosled[i] + 1 for i in range(n)])