from collections import deque

def najmanji_broj_koraka(matrica):
    start = None
    cilj = None
    redovi = len(matrica)
    kolone = len(matrica[0])

    for i in range(redovi):
        for j in range(kolone):
            if matrica[i][j] == 'S':
                start = (i, j)
            elif matrica[i][j] == 'C':
                cilj = (i, j)

    red_queue = deque([(start, 0)])

    while red_queue:
        (trenutni_polozaj, trenutni_koraci) = red_queue.popleft()

        i, j = trenutni_polozaj

        if trenutni_polozaj == cilj:
            return trenutni_koraci

        moguci_potezi = [(i-1, j), (i+1, j), (i, j-1), (i, j+1)]

        for potez in moguci_potezi:
            x, y = potez

            if 0 <= x < redovi and 0 <= y < kolone and matrica[x][y] != 'T':
                red_queue.append(((x, y), trenutni_koraci + 1))
                matrica[x][y] = 'T'  # obeležavamo posecena polja da ih ne bi ponovo posetili

    return -1  # ako cilj nije dostižan

# Unos podataka
R, K = map(int, input().split())
matrica = [list(input().split()) for _ in range(R)]

# Poziv funkcije i ispis rezultata
rezultat = najmanji_broj_koraka(matrica)
print(rezultat)