import itertools

def udaljenost(l1, l2):
    return ((l1[0] - l2[0])**2 + (l1[1] - l2[1])**2)**0.5

def najkraca_distanca(lokacije):
    najbolji_redosled = None
    najmanja_distanca = float('inf')
    
    for permutacija in itertools.permutations(lokacije):
        distanca = 0
        for i in range(len(permutacija) - 1):
            distanca += udaljenost(permutacija[i], permutacija[i + 1])
        
        if distanca < najmanja_distanca:
            najmanja_distanca = distanca
            najbolji_redosled = permutacija
    
    return najbolji_redosled

n = int(input())
lokacije = [list(map(float, input().split())) for _ in range(n)]
rezultat = najkraca_distanca(lokacije)
print(" ".join(str(lokacija) for lokacija in rezultat))