from collections import deque

def nadji_pocetak_i_cilj(matrica):
    for i in range(len(matrica)):
        for j in range(len(matrica[i])):
            if matrica[i][j] == 'S':
                pocetak = (i, j)
            elif matrica[i][j] == 'C':
                cilj = (i, j)
    return pocetak, cilj

def nadji_susede(x, y, matrica):
    susedi = []
    koraci = [(0, 1), (1, 0), (0, -1), (-1, 0)]   
    
    for dx, dy in koraci:
        nx, ny = x + dx, y + dy
        if 0 <= nx < len(matrica) and 0 <= ny < len(matrica[0]) and matrica[nx][ny] != 'T':
            susedi.append((nx, ny))
    
    return susedi

def najmanji_broj_koraka(matrica):
    pocetak, cilj = nadji_pocetak_i_cilj(matrica)
    red = deque([(pocetak, 0)])
    poseceno = set()

    while red:
        (trenutni_x, trenutni_y), trenutni_koraci = red.popleft()

        if (trenutni_x, trenutni_y) == cilj:
            return trenutni_koraci

        if (trenutni_x, trenutni_y) not in poseceno:
            poseceno.add((trenutni_x, trenutni_y))

            for sused_x, sused_y in nadji_susede(trenutni_x, trenutni_y, matrica):
                red.append(((sused_x, sused_y), trenutni_koraci + 1))

R, K = map(int, input().split())
matrica = [input().split() for _ in range(R)]