import itertools
def distance(p1, p2):
    return ((p1[0] - p2[0])  2 + (p1[1] - p2[1])  2) ** 0.5
def total_distance(order, points):
    total_dist = 0
    current_position = (0, 0)
    for ball_index in order:
        ball_position = points[ball_index]
        total_dist += distance(current_position, ball_position)
        current_position = ball_position
    return total_dist
def find_shortest_path(n, balls):
    indices = list(range(n))
    all_permutations = itertools.permutations(indices)
    min_distance = float('inf')
    best_order = None
    for order in all_permutations:
        current_distance = total_distance(order, balls)
        if current_distance < min_distance:
            min_distance = current_distance
            best_order = order
    return bestorder
n = int(input())
balls = [list(map(float, input().split())) for  in range(n)]
balls.sort(key=lambda x: 126 / x[1])
result = find_shortest_path(n, balls)
result_obrnut = tuple(reversed(result))
print(" ".join(str(x + 1) for x in result_obrnut))