#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int n;
vector<pair<double, double>> balls;

double distance(pair<double, double> ball1, pair<double, double> ball2) {
    double x1 = 126 / ball1.second;
    double x2 = 126 / ball2.second;
    double y1 = ball1.first;
    double y2 = ball2.first;
    return sqrt(pow(x1 - x2, 2) + pow(y1 - y2, 2));
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        double y, m;
        cin >> y >> m;
        balls.push_back(make_pair(y, m));
    }

    vector<pair<double, int>> pos_balls;
    vector<pair<double, int>> neg_balls;
    for (int i = 0; i < n; i++) {
        if (balls[i].second > 0) {
            pos_balls.push_back(make_pair(balls[i].first, i));
        } else {
            neg_balls.push_back(make_pair(balls[i].first, i));
        }
    }

    sort(pos_balls.begin(), pos_balls.end());
    sort(neg_balls.begin(), neg_balls.end());

    vector<int> order;
    for (int i = 0; i < pos_balls.size(); i++) {
        order.push_back(pos_balls[i].second);
    }
    for (int i = 0; i < neg_balls.size(); i++) {
        order.push_back(neg_balls[i].second);
    }

    double min_dist = INFINITY;
    vector<int> min_order;
    do {
        double dist = 0;
        for (int i = 0; i < n - 1; i++) {
            dist += distance(balls[order[i]], balls[order[i + 1]]);
        }
        if (dist < min_dist) {
            min_dist = dist;
            min_order = order;
        }
    } while (next_permutation(order.begin(), order.end()));

    for (int i = n - 1; i >= 0; i--) {
        cout << min_order[i] + 1 << " ";
    }
    cout << endl;

    return 0;
}