#include <iostream>
#include <queue>
#include <vector>

using namespace std;

struct Point {
    int x, y, steps;
};

int main() {
    int R, K;
    cin >> R >> K;

    vector<vector<char>> matrix(R, vector<char>(K));
    Point start, end;

    for (int i = 0; i < R; ++i) {
        for (int j = 0; j < K; ++j) {
            cin >> matrix[i][j];
            if (matrix[i][j] == 'S') {
                start.x = i;
                start.y = j;
                start.steps = 0;
            } else if (matrix[i][j] == 'C') {
                end.x = i;
                end.y = j;
            }
        }
    }

    queue<Point> q;
    q.push(start);
    vector<vector<bool>> visited(R, vector<bool>(K, false));
    visited[start.x][start.y] = true;

    int dx[] = {0, 0, 1, -1};
    int dy[] = {1, -1, 0, 0};

    while (!q.empty()) {
        Point current = q.front();
        q.pop();

        int x = current.x, y = current.y, steps = current.steps;

        if (x == end.x && y == end.y) {
            cout << steps << endl;
            return 0;
        }

        for (int i = 0; i < 4; ++i) {
            int nx = x + dx[i];
            int ny = y + dy[i];

            if (nx >= 0 && nx < R && ny >= 0 && ny < K && !visited[nx][ny] && matrix[nx][ny] != 'T') {
                q.push({nx, ny, steps + 1});
                visited[nx][ny] = true;
            }
        }

        if (matrix[x][y] == 'T') {
            for (int i = 0; i < R; ++i) {
                for (int j = 0; j < K; ++j) {
                    if (matrix[i][j] == 'T' && (i != x || j != y) && !visited[i][j]) {
                        q.push({i, j, steps + 1});
                        visited[i][j] = true;
                    }
                }
            }
        }
    }

    cout << "Nije pronadjen put od S do C." << endl;
    return 0;
}