import itertools
import math

def distance(point1, point2):
    x1, y1 = point1
    x2, y2 = point2
    return math.sqrt((x1 - x2)**2 + (y1 - y2)**2)

n = int(input())
balls = [list(map(float, input().split())) for _ in range(n)]
balls.sort(key=lambda x: x[0])

destinations = []
for i in range(n):
    mass = balls[i][1]
    x_coordinate = 126 / mass if mass != 0 else float('inf')
    dest_x = round(x_coordinate)
    destinations.append((dest_x, balls[i][0]))

orders = list(itertools.permutations(range(1, n + 1)))

shortest_distance = float('inf')
optimal_order = []

for order in orders:
    total_distance = 0
    current_position = (0, 0)

    for ball in order:
        new_distance = distance(current_position, destinations[ball - 1])
        total_distance += new_distance
        current_position = destinations[ball - 1]

    if total_distance < shortest_distance:
        shortest_distance = total_distance
        optimal_order = list(order)

print(*optimal_order)