from collections import deque

def valid_neighbours(matrix, visited, row, col):
    neighbours = []
    directions = [(-1, 0), (1, 0), (0, -1), (0, 1)]  
    
    for dr, dc in directions:
        r, c = row + dr, col + dc
        if 0 <= r < len(matrix) and 0 <= c < len(matrix[0]) and not visited[r][c] and matrix[r][c] != 'T':
            neighbours.append((r, c))
    
    return neighbours

def shortest_path(matrix):
    rows, cols = len(matrix), len(matrix[0])
    start = None
    for r in range(rows):
        for c in range(cols):
            if matrix[r][c] == 'S':
                start = (r, c)
                break
        if start:
            break
    
    visited = [[False for _ in range(cols)] for _ in range(rows)]
    visited[start[0]][start[1]] = True
    queue = deque([(start, 0)])  
    
    while queue:
        (row, col), steps = queue.popleft()
        
        if matrix[row][col] == 'C':
            return steps
        
        for neighbour in valid_neighbours(matrix, visited, row, col):
            r, c = neighbour
            visited[r][c] = True
            queue.append(((r, c), steps + 1))
    
    return -1  

R, K = map(int, input().split())
matrix = [list(input().split()) for _ in range(R)]

result = shortest_path(matrix)
print(result)