def calculate_distance(point1, point2):
    # Calculate the Euclidean distance between two points
    return ((point1[0] - point2[0]) ** 2 + (point1[1] - point2[1]) ** 2) ** 0.5

def calculate_total_distance(route):
    # Calculate the total distance of a route by summing up the distances between consecutive points
    total_distance = 0
    for i in range(len(route) - 1):
        total_distance += calculate_distance(route[i], route[i + 1])
    return total_distance

def generate_permutations(lst):
    if not lst:
        return [[]]

    result = []
    for i in range(len(lst)):
        rest = lst[:i] + lst[i + 1:]
        rest_permutations = generate_permutations(rest)
        result.extend([[lst[i]] + p for p in rest_permutations])

    return result

def calculate_shortest_route(balls):
    shortest_route = None
    shortest_distance = float('inf')

    permutations = generate_permutations(balls)

    for perm in permutations:
        total_distance = calculate_total_distance(perm)
        if total_distance < shortest_distance:
            shortest_distance = total_distance
            shortest_route = perm

    return shortest_route
num_balls = int(input())
balls = []
for i in range(num_balls):
    y, mass = map(float, input(f"Enter y-coordinate and mass for ball {i + 1} (separated by space): ").split())
    x = 126 / mass
    balls.append((x, y))
shortest_route = calculate_shortest_route(balls)
result = ' '.join(str(balls.index(ball) + 1) for ball in shortest_route)
print(result)