from collections import deque
def find_start(matrix):
    for i in range(len(matrix)):
        for j in range(len(matrix[i])):
            if matrix[i][j] == 'S':
                return (i, j)
def is_valid_move(matrix, visited, x, y):
    return 0 <= x < len(matrix) and 0 <= y < len(matrix[0]) and matrix[x][y] != 'T' and not visited[x][y]
def find_shortest_path(matrix):
    start = find_start(matrix)
    queue = deque([(start, 0)])
    visited = [[False] * len(matrix[0]) for _ in range(len(matrix))]
    while queue:
        (x, y), steps = queue.popleft()
        if matrix[x][y] == 'C':
            return steps
        visited[x][y] = True
        moves = [(x-1, y), (x+1, y), (x, y-1), (x, y+1)]
        for move in moves:
            new_x, new_y = move
            if is_valid_move(matrix, visited, new_x, new_y):
                if matrix[new_x][new_y] == 'T':
                    queue.append(((new_x, new_y), steps))
                else:
                    queue.append(((new_x, new_y), steps + 1))
R, K = map(int, input().split())
matrix = [input().split() for _ in range(R)]
result = find_shortest_path(matrix)
print(result)