using System;
using System.Linq;

class Program
{
    static void Main()
    {
        Console.Write("Unesite broj šibica: ");
        int brojSibica = Convert.ToInt32(Console.ReadLine());

        int[] duzineSibica = UnesiDuzineSibica(brojSibica);

        bool mozeFormiratiKvadrat = ProveriKvadrat(duzineSibica);

        if (mozeFormiratiKvadrat)
        {
            Console.WriteLine("1");
        }
        else
        {
            Console.WriteLine("0");
        }
    }

    static int[] UnesiDuzineSibica(int brojSibica)
    {
        Console.WriteLine("Unesite dužine šibica:");

        int[] duzineSibica = new int[brojSibica];

        for (int i = 0; i < brojSibica; i++)
        {
            Console.Write($"Šibica {i + 1}: ");
            duzineSibica[i] = Convert.ToInt32(Console.ReadLine());
        }

        return duzineSibica;
    }

    static bool ProveriKvadrat(int[] duzineSibica)
    {
        if (duzineSibica.Length < 4)
        {
            return false;
        }

        int ukupnaDuzina = duzineSibica.Sum();
        if (ukupnaDuzina % 4 != 0)
        {
            return false;
        }
        Array.Sort(duzineSibica);
        Array.Reverse(duzineSibica);

        return RekurzivnaProveraKvadrata(duzineSibica, new int[4], 0, ukupnaDuzina / 4);
    }

    static bool RekurzivnaProveraKvadrata(int[] duzineSibica, int[] strane, int indeks, int ciljnaDuzina)
    {
        if (indeks == duzineSibica.Length)
        {
            return strane.All(s => s == ciljnaDuzina);
        }
        for (int i = 0; i < 4; i++)
        {
            if (strane[i] + duzineSibica[indeks] <= ciljnaDuzina)
            {
                strane[i] += duzineSibica[indeks];

                if (RekurzivnaProveraKvadrata(duzineSibica, strane, indeks + 1, ciljnaDuzina))
                {
                    return true;
                }
                strane[i] -= duzineSibica[indeks];
            }
        }

        return false;
    }
}