from collections import defaultdict

def create_tournament_order(k, results):
    players = set(range(2**k))
    winners = set()

    for result in results:
        winner, loser = result
        winners.add(winner)
        players.remove(loser)

    while len(winners) > 1:
        new_winners = set()
        new_players = set()

        for match in zip(winners, iter(players)):
            winner, loser = max(match), min(match)
            new_winners.add(winner)
            new_players.add(loser)

        winners, players = new_winners, new_players

    return list(winners), list(players)


k = int(input())
results = [list(map(int, input().split())) for _ in range(2**k - 1)]


winner, second_place = create_tournament_order(k, results)
print(winner[0])
print(second_place[0])


for i in range(k - 1):
    round_players, results = create_tournament_order(k - i - 1, results)
    print(round_players)