def najmanji_broj_koraka(matrica, start):
    redovi, kolone = len(matrica), len(matrica[0])
    cilj = None

    for i in range(redovi):
        for j in range(kolone):
            if matrica[i][j] == 'C':
                cilj = (i, j)
                break

    red, kolona = start
    queue = [(red, kolona, 0)]  # Redosled: red, kolona, broj koraka
    posetili = set()

    while queue:
        r, k, koraci = queue.pop(0)

        if (r, k) == cilj:
            return koraci

        if (r, k) not in posetili:
            posetili.add((r, k))

            # Krecemo se gore
            if r > 0 and matrica[r-1][k] != 'T':
                queue.append((r-1, k, koraci + 1))

            # Krecemo se dole
            if r < redovi - 1 and matrica[r+1][k] != 'T':
                queue.append((r+1, k, koraci + 1))

            # Krecemo se levo
            if k > 0 and matrica[r][k-1] != 'T':
                queue.append((r, k-1, koraci + 1))

            # Krecemo se desno
            if k < kolone - 1 and matrica[r][k+1] != 'T':
                queue.append((r, k+1, koraci + 1))

    return -1  # Ako nije pronaden put do cilja


R, K = map(int, input().split())
matrica = [input().split() for _ in range(R)]

start = None
for i in range(R):
    for j in range(K):
        if matrica[i][j] == 'S':
            start = (i, j)
            break


rezultat = najmanji_broj_koraka(matrica, start)
print(rezultat)