def bfs(matrix, start, end):
    visited = set()
    queue = [(start, 0)]
    while queue:
        (pos, steps) = queue.pop(0)
        if pos == end:
            return steps
        visited.add(pos)
        for neighbor in get_neighbors(pos, matrix):
            if neighbor not in visited:
                queue.append((neighbor, steps + 1))

def get_neighbors(pos, matrix):
    neighbors = []
    for dx in (-1, 0, 1):
        for dy in (-1, 0, 1):
            if dx != 0 or dy != 0:
                new_pos = (pos[0] + dx, pos[1] + dy)
                if 0 <= new_pos[0] < len(matrix) and 0 <= new_pos[1] < len(matrix[0]) and matrix[new_pos[0]][new_pos[1]] != ".":
                    neighbors.append(new_pos)
    return neighbors

R,K = map(int, input().split())
matrix = []
for i in range(R):
    single_row = list(input().split())
    matrix.append(single_row)
for i in range(R):
    for j in range(K):
        if matrix[i][j] == 'S':
            start = (i,j)
        if matrix[i][j] == 'C':
            end = (i,j)
steps = bfs(matrix, start, end)
print(steps)