from collections import deque

def valid(poz, rows, cols):
    return 0 <= poz[0] < rows and 0 <= poz[1] < cols

def najkraci_put(matrica):
    rows, cols = len(matrica), len(matrica[0])
    start, cilj = None, None

    for i in range(rows):
        for j in range(cols):
            if matrica[i][j] == 'S':
                start = (i, j)
            elif matrica[i][j] == 'C':
                cilj = (i, j)

    queue = deque([(start, 0)])
    visited = set()
    visited.add(start)

    while queue:
        poz, koraci = queue.popleft()

        if poz == cilj:
            return koraci

        x, y = poz
        for dx, dy in [(1, 0), (-1, 0), (0, 1), (0, -1)]:
            nova_poz = (x + dx, y + dy)
            if valid(nova_poz, rows, cols) and nova_poz not in visited and matrica[nova_poz[0]][nova_poz[1]] != 'T':
                visited.add(nova_poz)
                queue.append((nova_poz, koraci + 1))

    return -1  # Ako se cilj ne može dostici


R, K = map(int, input().split())
matrica = [input().split() for _ in range(R)]


rezultat = najkraci_put(matrica)
print(rezultat)