def reconstruct_tournament(k, match_results):
    num_players = 2 ** k
    losses = {player: 0 for player in range(num_players)}
   
    for winner, loser in match_results:
        losses[loser] += 1

    winner = [player for player, loss_count in losses.items() if loss_count == 0][0]

    runner_up = [loser for winner, loser in match_results if winner == winner][0]

    eliminated_players = [player for player, loss_count in losses.items() if loss_count == 1 and player != runner_up]

    output = [winner, runner_up] + eliminated_players

    return output

k = int(input())

match_results = []
for _ in range(2 ** k - 1):
    winner, loser = map(int, input().split())
    match_results.append((winner, loser))

tournament_order = reconstruct_tournament(k, match_results)

print(tournament_order[0])  
print(tournament_order[1]) 
print(' '.join(map(str, tournament_order[2:])))