def can_form_square(n, matches):
    if n < 4:
        return 0

    # Sort the matches in descending order for efficient backtracking
    matches.sort(reverse=True)

    # Helper function to explore different combinations
    def backtrack(index, sides):
        if index == n:
            return all(side == sides[0] for side in sides)  # All sides are equal, forming a square

        for i in range(4):
            if sides[i] >= matches[index]:
                sides[i] -= matches[index]
                if backtrack(index + 1, sides):
                    return True
                sides[i] += matches[index]

        return False

    # Check if a square can be formed
    return backtrack(0, [0] * 4)

# Taking input from the user
n = int(input())
matches = list(map(int, input().split()))

result = can_form_square(n, matches)

# Print the result
print(1 if result else 0)