#include <iostream>
#include <queue>
#include <vector>

using namespace std;
struct Position {
    int row, col, steps;
};
bool isValid(int row, int col, int R, int K, const vector<vector<char>>& matrix, vector<vector<bool>>& visited) {
    return (row >= 0 && row < R&& col >= 0 && col < K&& matrix[row][col] != 'T' && !visited[row][col]);
}
int findShortestPath(const vector<vector<char>>& matrix, int R, int K, Position start, Position end) {
    int dr[] = { -1, 1, 0, 0 };
    int dc[] = { 0, 0, -1, 1 };

    queue<Position> q;
    q.push(start);

    vector<vector<bool>> visited(R, vector<bool>(K, false));
    visited[start.row][start.col] = true;

    while (!q.empty()) {
        Position current = q.front();
        q.pop();

        if (current.row == end.row && current.col == end.col) {
            return current.steps;
        }
        for (int i = 0; i < 4; i++) {
            int newRow = current.row + dr[i];
            int newCol = current.col + dc[i];

            if (isValid(newRow, newCol, R, K, matrix, visited)) {
                visited[newRow][newCol] = true;
                q.push({ newRow, newCol, current.steps + 1 });
            }
        }
    }
    return -1;
}
int main() {
    int R, K;
    cin >> R >> K;
    vector<vector<char>> matrix(R, vector<char>(K));
    Position start, end;
    for (int i = 0; i < R; i++) {
        for (int j = 0; j < K; j++) {
            cin >> matrix[i][j];
            if (matrix[i][j] == 'S') {
                start = { i, j, 0 };
            }
            else if (matrix[i][j] == 'C') {
                end = { i, j, 0 };
            }
        }
    }
    int result = findShortestPath(matrix, R, K, start, end);
    cout << result << endl;
    return 0;
}