#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

struct Coordinate
{
    double x;
    double y;
    int index;

    bool operator<(const Coordinate &other) const
    {
        return x < other.x;
    }
};

double distance(const Coordinate &a, const Coordinate &b)
{
    return sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2));
}

int main()
{
    int n;
    cin >> n;
    vector<Coordinate> coords;

    for (int i = 0; i < n; i++)
    {
        double y, m;
        cin >> y >> m;
        coords.push_back({126 / m, y, i + 1});
    }

    if (coords[0].y == 0 && coords[n - 1].y == 0)
    {
        sort(coords.begin(), coords.end(), [](const Coordinate &a, const Coordinate &b)
             { return a.index < b.index; });
        for (const auto &coord : coords)
        {
            cout << coord.index << " ";
        }
        cout << endl;
    }
    else
    {
        vector<vector<Coordinate>> permutations;
        do
        {
            permutations.push_back(coords);
        } while (next_permutation(coords.begin(), coords.end()));

        double shortest = 10000000;
        vector<Coordinate> shortestPermutation;

        for (const auto &permutation : permutations)
        {
            double length = 0;
            for (int i = 0; i < permutation.size() - 1; i++)
            {
                length += distance(permutation[i], permutation[i + 1]);
            }
            if (length < shortest)
            {
                shortest = length;
                shortestPermutation = permutation;
            }
        }
        for (const auto &coord : shortestPermutation)
        {
            cout << coord.index << " ";
        }
    }

    return 0;
}