#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

struct Pozicija {
    int red, kolona, koraci;
};

int najmanji_broj_koraka(vector<vector<char>>& matrica) {
    int redovi = matrica.size();
    int kolone = matrica[0].size();

    // Pronadi start i cilj
    pair<int, int> start, cilj;
    for (int i = 0; i < redovi; ++i) {
        for (int j = 0; j < kolone; ++j) {
            if (matrica[i][j] == 'S') {
                start = make_pair(i, j);
            } else if (matrica[i][j] == 'C') {
                cilj = make_pair(i, j);
            }
        }
    }

    int red = start.first;
    int kolona = start.second;
    set<pair<int, int>> poseti;
    queue<Pozicija> red_queue;
    red_queue.push({red, kolona, 0});

    while (!red_queue.empty()) {
        Pozicija trenutna = red_queue.front();
        red_queue.pop();

        red = trenutna.red;
        kolona = trenutna.kolona;
        int koraci = trenutna.koraci;

        if (make_pair(red, kolona) == cilj) {
            return koraci;
        }

        if (red >= 0 && red < redovi && kolona >= 0 && kolona < kolone && poseti.find({red, kolona}) == poseti.end()) {
            poseti.insert({red, kolona});

            if (matrica[red][kolona] == 'T') {
                for (int i = 0; i < redovi; ++i) {
                    for (int j = 0; j < kolone; ++j) {
                        if (matrica[i][j] == 'T' && make_pair(i, j) != make_pair(red, kolona)) {
                            red_queue.push({i, j, koraci + 1});
                        }
                    }
                }
            } else {
                red_queue.push({red + 1, kolona, koraci + 1});
                red_queue.push({red - 1, kolona, koraci + 1});
                red_queue.push({red, kolona + 1, koraci + 1});
                red_queue.push({red, kolona - 1, koraci + 1});
            }
        }
    }

    return -1;  // Cilj nije dostižan
}

int main() {
    int R, K;
    cin >> R >> K;

    vector<vector<char>> matrica(R, vector<char>(K));
    for (int i = 0; i < R; ++i) {
        for (int j = 0; j < K; ++j) {
            cin >> matrica[i][j];
        }
    }

    int rezultat = najmanji_broj_koraka(matrica);
    cout << rezultat << endl;

    return 0;
}