#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int calculate_distance(int s_row, int s_col, int t_row, int t_col) {
    return abs(s_row - t_row) + abs(s_col - t_col);
}

int najblizeTodA(vector<vector<char>>& matrix, int rows, int cols, char A) {
    int A_row, A_col;
    vector<pair<int, int>> t_positions;

    for (int i = 0; i < rows; ++i) {
        for (int j = 0; j < cols; ++j) {
            if (matrix[i][j] == A) {
                A_row = i;
                A_col = j;
            } else if (matrix[i][j] == 'T') {
                t_positions.push_back(make_pair(i, j));
            }
        }
    }

    int min_distance = 40000000;

    for (const auto& t_pos : t_positions) {
        int t_row = t_pos.first;
        int t_col = t_pos.second;
        int distance = calculate_distance(A_row, A_col, t_row, t_col);

        if (distance < min_distance) {
            min_distance = distance;
        }
    }

    return min_distance;
}

int SodC(vector<vector<char>> matrix, int rows, int cols) {
    int s_row, s_col;
    int c_row, c_col;
    for (int i = 0; i < rows; i++) {
        for (int j = 0; j < cols; j++) {
            if (matrix[i][j] == 'S') {
                s_row = i;
                s_col = j;
            } else if (matrix[i][j] == 'C') {
                c_row = i;
                c_col = j;
            }
        }
    }
    return calculate_distance(s_row, s_col, c_row, c_col);
}

int main() {
    int rows, cols;
    cin >> rows >> cols;  // Read the number of rows and columns

    vector<vector<char>> matrix(rows, vector<char>(cols));

    for (int i = 0; i < rows; i++) {
        for (int j = 0; j < cols; j++) {
            cin >> matrix[i][j];
        }
    }

    cout << min(SodC(matrix, rows, cols), najblizeTodA(matrix, rows, cols, 'S') + najblizeTodA(matrix, rows, cols, 'C'));

    return 0;
}