from collections import deque

def nadji_najkraci_put(r, k, matrica):
    start_x, start_y, cilj_x, cilj_y, broj_teleportala = 0, 0, 0, 0, 0
    teleportali = []

    for i in range(r):
        for j in range(k):
            if matrica[i][j] == 'S':
                start_x, start_y = i, j
            elif matrica[i][j] == 'C':
                cilj_x, cilj_y = i, j
            elif matrica[i][j] == 'T':
                teleportali.append((i, j))

    def bfs(x, y, target_x, target_y):
        poseceno = set()
        red = deque([(x, y, 0)])

        while red:
            trenutni_x, trenutni_y, koraci = red.popleft()

            if trenutni_x == target_x and trenutni_y == target_y:
                return koraci

            if (trenutni_x, trenutni_y) in poseceno:
                continue

            poseceno.add((trenutni_x, trenutni_y))

            for dx, dy in [(0, 1), (0, -1), (1, 0), (-1, 0)]:
                novo_x, novo_y = trenutni_x + dx, trenutni_y + dy

                if 0 <= novo_x < r and 0 <= novo_y < k and matrica[novo_x][novo_y] != 'T' and (novo_x, novo_y) not in poseceno:
                    red.append((novo_x, novo_y, koraci + 1))

        return float('inf')

    rezultat = bfs(start_x, start_y, cilj_x, cilj_y) if broj_teleportala == 0 else min(bfs(start_x, start_y, tx, ty) + bfs(tx, ty, cilj_x, cilj_y) for tx, ty in teleportali)
    return rezultat

if __name__ == "__main__":
    redovi, kolone = map(int, input().split())
    polja = [list(input().strip()) for _ in range(redovi)]

    rezultat = nadji_najkraci_put(redovi, kolone, polja)
    print(rezultat)