import itertools

def udaljenost(lopta1, lopta2):
    x1, y1 = lopta1
    x2, y2 = lopta2
    return ((x1 - x2) ** 2 + (y1 - y2) ** 2) ** 0.5

def najkraca_ruta(n, lopte):
    najkraca_ruta = None
    najmanja_udaljenost = float('inf')

    for permutacija in itertools.permutations(range(n)):
        ruta = list(permutacija)
        ukupna_udaljenost = 0

        for i in range(1, n):
            ukupna_udaljenost += udaljenost(lopte[ruta[i-1]], lopte[ruta[i]])

        if ukupna_udaljenost < najmanja_udaljenost:
            najmanja_udaljenost = ukupna_udaljenost
            najkraca_ruta = ruta

    return najkraca_ruta

# Citanje ulaznih podataka
n = int(input())
lopte = [tuple(map(float, input().split())) for _ in range(n)]

# Pozivanje funkcije i ispis rezultata
rezultat = najkraca_ruta(n, lopte)
print(*rezultat)