from collections import deque

def najmanji_broj_koraka(matrica, start, cilj):
    redovi, kolone = len(matrica), len(matrica[0])
    posetio = set()
    red = deque([(start, 0)])

    while red:
        (trenutna_pozicija, broj_koraka) = red.popleft()
        i, j = trenutna_pozicija

        if trenutna_pozicija == cilj:
            return broj_koraka

        if trenutna_pozicija in posetio:
            continue

        posetio.add(trenutna_pozicija)

        if i > 0 and matrica[i-1][j] != '#':
            red.append(((i-1, j), broj_koraka+1))
        if i < redovi - 1 and matrica[i+1][j] != '#':
            red.append(((i+1, j), broj_koraka+1))
        if j > 0 and matrica[i][j-1] != '#':
            red.append(((i, j-1), broj_koraka+1))
        if j < kolone - 1 and matrica[i][j+1] != '#':
            red.append(((i, j+1), broj_koraka+1))

        if matrica[i][j] == 'T':
            for x in range(redovi):
                for y in range(kolone):
                    if (x, y) != trenutna_pozicija and matrica[x][y] == 'T':
                        red.append(((x, y), broj_koraka))

# Citanje ulaznih podataka
R, K = map(int, input().split())
matrica = [input().split() for _ in range(R)]

# Pronalaženje pozicija starta (S) i cilja (C)
start = None
cilj = None
for i in range(R):
    for j in range(K):
        if matrica[i][j] == 'S':
            start = (i, j)
        elif matrica[i][j] == 'C':
            cilj = (i, j)

# Pozivanje funkcije i ispis rezultata
rezultat = najmanji_broj_koraka(matrica, start, cilj)
print(rezultat)