#include <iostream>
#include <vector>
#include <unordered_map>

using namespace std;

void generateTournamentOrder(int k, vector<pair<int, int>>& results) {
    unordered_map<int, int> playerRounds;
    vector<int> eliminatedPlayers;

    for (int i = 0; i < results.size(); i++) {
        int winner = results[i].first;
        int loser = results[i].second;

        playerRounds[winner]++;
        playerRounds[loser]++;

        if (playerRounds[winner] > k) {
            eliminatedPlayers.push_back(winner);
        }

        if (playerRounds[loser] > k) {
            eliminatedPlayers.push_back(loser);
        }
    }

    cout << "Tournament Winner: " << results[results.size() - 1].first << endl;
    cout << "Runner-up: " << results[results.size() - 1].second << endl;

    for (int i = k; i >= 1; i--) {
        cout << "Eliminated in Round " << i << ": ";
        for (int j = 0; j < eliminatedPlayers.size(); j++) {
            if (playerRounds[eliminatedPlayers[j]] == i) {
                cout << eliminatedPlayers[j] << " ";
            }
        }
        cout << endl;
    }
}

int main() {
    int k;
    cin >> k;

    vector<pair<int, int>> results;
    int winner, loser;

    while (cin >> winner >> loser) {
        results.push_back(make_pair(winner, loser));
    }

    generateTournamentOrder(k, results);

    return 0;
}