#include <iostream>
#include <vector>
#include <algorithm>

bool canFormSquare(std::vector<int>& matchsticks) {
    int sum = 0;
    for (int length : matchsticks) {
        sum += length;
    }
    if (sum % 4 != 0) {
        return false;
    }
    int sideLength = sum / 4;
    std::sort(matchsticks.rbegin(), matchsticks.rend());
    std::vector<int> sides(4, 0);
    return (matchsticks, sides, 0, sideLength);
}

bool dfs(std::vector<int>& matchsticks, std::vector<int>& sides, int index, int sideLength) {
    if (index == matchsticks.size()) {
        return sides[0] == sideLength && sides[1] == sideLength && sides[2] == sideLength;
    }
    for (int i = 0; i < 4; i++) {
        if (sides[i] + matchsticks[index] <= sideLength) {
            sides[i] += matchsticks[index];
            if (dfs(matchsticks, sides, index + 1, sideLength)) {
                return true;
            }
            sides[i] -= matchsticks[index];
        }
    }
    return false;
}

int main() {
    int n;
    std::cin >> n;
    std::vector<int> matchsticks(n);
    for (int i = 0; i < n; i++) {
        std::cin >> matchsticks[i];
    }
    std::cout << canFormSquare(matchsticks) << std::endl;
    return 0;
}