import itertools
def calculate_distance(point1, point2):
    return ((point1[0] - point2[0])**2 + (point1[1] - point2[1])**2)**0.5
def total_distance(order, points):
    total = 0
    for i in range(len(order)-1):
        total += calculate_distance(points[order[i]], points[order[i+1]])
    return total
def optimal_order(n, points):
    min_distance = float('inf')
    best_order = []
    for order in itertools.permutations(range(n)):
        distance = total_distance(order, points)
        if distance < min_distance:
            min_distance = distance
            best_order = order

    return best_order
n = int(input())
points = []
for _ in range(n):
    y, m = map(float, input().split())
    points.append((y, m))
result_order = optimal_order(n, points)
print(" ".join(map(str, [x+1 for x in result_order])))